* PACKAGE DHEUN    !" P \infty  ʬ( Heun Scheme )
*
*"  [HIS] 96/03/16 (takepiro) 
*
***********************************************************************
      SUBROUTINE DHEUN
     O             ( PSI3  , ZETA3 , T3  , 
     I               PSI2  , ZETA2 , T2  , 
     I               RAYL  , PRND  , QINT, 
     C               DX    , DZ    , DT  ,
     W               TNDZ  , TNDT  ,
     W               AJAC  , ALAP   ) 
*
*"    << Heun schemeˤ꼡ƥåפʪ̤׻ (P \infty ) >>
*" 
* [PARAM]
#include        "zcdim.F"            !" ʻ, ȿ
*
* [OUTPUT]
      REAL PSI3  ( 0:NX+1 , 0:NZ+1 ) !" ήؿ(STEP)
      REAL ZETA3 ( 0:NX+1 , 0:NZ+1 ) !" (STEP)
      REAL T3    ( 0:NX+1 , 0:NZ+1 ) !" (STEP)
*
* [INPUT]
      REAL PSI2  ( 0:NX+1 , 0:NZ+1 ) !" ήؿ(1STEP)
      REAL ZETA2 ( 0:NX+1 , 0:NZ+1 ) !" (1STEP)
      REAL T2    ( 0:NX+1 , 0:NZ+1 ) !" (1STEP)
*
      REAL PRND                 !" ץȥ(ߡ)
      REAL RAYL                 !" 쥤꡼
      REAL QINT                 !" ǮΨ
*
      REAL DX                   !" X γʻֳ
      REAL DZ                   !" Z γʻֳ
      REAL DT                   !" ֳִ
*
* [WORK]
      REAL TNDZ ( 0:NX+1 , 0:NZ+1 ) !"  1 ʳǤα٤λѲ(ߡ)
      REAL TNDT ( 0:NX+1 , 0:NZ+1 ) !"  1 ʳǤβ٤λѲ
      REAL AJAC ( 0:NX+1 , 0:NZ+1 ) !"䥳ӥ
      REAL ALAP ( 0:NX+1 , 0:NZ+1 ) !"ץ饷
*
*  [INTERNAL WORK]
      INTEGER IX                   !"롼ץ
      INTEGER IZ                   !"롼ץ
*
      LOGICAL OFIRST
      DATA    OFIRST  / .TRUE. /
*    
      SAVE  OFIRST 
*
      IF( OFIRST ) THEN
         OFIRST = .FALSE.
         CALL MSGDMP('M','DHEUN',
     &               'HEUN SCHEME TIME INTEGRATE : 96/03/16' )
         CALL MSGDMP('M','DHEUN',
     &               '***** INFINITE PRNDTL NUMBER APPROX. *****' )
      ENDIF
*
*"        < 1. Euler scheme : dummyͤ׻ >
*
      CALL DEULTT
     O      ( TNDT  , 
     I        PSI2  , T2  , 
     C        QINT  , 
     C        DX    , DZ    , 
     W        AJAC  , ALAP    )
*
      DO 1040 IX = 1 , NX
        DO 1030 IZ = 1 , NZ
              T3(IX,IZ)
     &    =   T2(IX,IZ) + DT * TNDT( IX, IZ )
 1030   CONTINUE
 1040 CONTINUE
*
      CALL DTMP2Z               !"  ٤鱲٤η׻(P inf )
     O       ( ZETA3 , 
     I         T3    , 
     C         RAYL  , 
     C         DX    , DZ    , DT  ,
     W         ALAP    )
*
      CALL DBNDR                !" ŬѤήؿη׻
     O      ( PSI3  , 
     M        ZETA3 , T3   ,
     I        DX    , DZ    )
*
*"        < 2. ȿ >
*
      CALL DHEUZT
     M       ( T3    , 
     I         PSI3  , 
     I         T2    , TNDT  , 
     C         QINT  , 
     C         DX    , DZ    , DT  ,
     W         AJAC  , ALAP    )
*
      CALL DTMP2Z               !"  ٤鱲٤η׻(P inf )
     O       ( ZETA3 , 
     I         T3    , 
     C         RAYL  , 
     C         DX    , DZ    , DT  ,
     W         ALAP    )
*
      CALL DBNDR                !" ŬѤήؿη׻
     O      ( PSI3  , 
     M        ZETA3 , T3   ,
     I        DX    , DZ    )
*
      RETURN
      END
*****************************************************************
      SUBROUTINE DHEUZT        !" Heun scheme ˤ벹( 2 ʳ)
     M             ( T3    , 
     I               PSI3  , 
     I               T2    , TNDT  , 
     C               QINT  , 
     C               DX    , DZ    , DT  ,
     W               AJAC3 , ALAP3   )
*
* [PARAM]
#include        "zcdim.F"            !" ʻ, ȿ
*
* [OUTPUT]
      REAL T3 ( 0:NX+1 , 0:NZ+1 )    !" (STEP, ͽ)
*
* [INPUT]
      REAL PSI3  ( 0:NX+1 , 0:NZ+1 ) !" ήؿ(STEP)
      REAL T2    ( 0:NX+1 , 0:NZ+1 ) !" (1STEP)
      REAL TNDT  ( 0:NX+1 , 0:NZ+1 ) !"  1 ʳǤβ٤λѲ
*
      REAL QINT                      !" ǮΨ
      REAL DX                        !" X γʻֳ
      REAL DZ                        !" Z γʻֳ
      REAL DT                        !" ֳִ
*
* [WORK]
      REAL AJAC3 ( 0:NX+1 , 0:NZ+1 ) !" 䥳ӥ
      REAL ALAP3 ( 0:NX+1 , 0:NZ+1 ) !" ץ饷
*
*  [INTERNAL WORK]
      INTEGER IX                     !" 롼ץ
      INTEGER IZ                     !" 롼ץ
*
*"        < 1. 䥳ӥη׻ >
*
      CALL DARJAC
     O       ( AJAC3,
     I         PSI3 , T3  ,
     C         DX   , DZ   )
*
*"        < 2. ץ饷η׻ >
*
      CALL DLAPLA
     O       ( ALAP3,
     I         T3   ,
     C         DX   , DZ   )
*
*"        < 3. ƥåɤβ٤ͤη׻ >
*
      DO 3020 IX = 1 , NX
        DO 3010 IZ = 1 , NZ
             T3( IX,IZ ) 
     &    =  T2( IX,IZ ) 
     &     + DT*(   0.5 * TNDT( IX,IZ )  
     &            + 0.5 * ( AJAC3(IX,IZ) + ALAP3(IX,IZ) + QINT ) )
 3010   CONTINUE
 3020 CONTINUE
*
      RETURN
      END

